'use strict';
/*

    To use this input widget adapter you need to register it with your
    adapter registry.

*/

import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import { createComponentVNode, normalizeProps } from "inferno";
import { Component } from 'inferno';
import { Adapter } from 'component-registry';
import { interfaces } from 'isomorphic-schema';
import { IInputFieldWidget } from '../interfaces';
import { Input } from 'inferno-bootstrap';
import { renderString } from './common';
import { generateId } from './utils'; // Placeholder

var CheckboxWidget =
/*#__PURE__*/
function (_Component) {
  _inherits(CheckboxWidget, _Component);

  function CheckboxWidget(props) {
    var _this;

    _classCallCheck(this, CheckboxWidget);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CheckboxWidget).call(this, props));
    _this.state = {
      isChecked: props.value
    };
    _this.didGetChange = _this.didGetChange.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    return _this;
  }

  _createClass(CheckboxWidget, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value !== this.state.isChecked) {
        this.setState({
          isChecked: nextProps.value
        });
      }
    }
  }, {
    key: "didGetChange",
    value: function didGetChange(e) {
      this.props.onChange(this.props.propName, this.state.isChecked ? false : true);
    }
  }, {
    key: "render",
    value: function render(_ref) {
      var inputName = _ref.inputName,
          namespace = _ref.namespace,
          options = _ref.options,
          doesNotRenderLabel = _ref.doesNotRenderLabel,
          id = _ref.id;
      var field = this.props.adapter.context;
      var isValid = this.props.validationError || this.props.invariantError ? false : undefined;
      var ariaLabels = {
        'aria-invalid': isValid !== undefined,
        'aria-labelledby': doesNotRenderLabel ? undefined : id,
        'aria-label': doesNotRenderLabel ? renderString(field.label || 'inferno-formlib--InputField', options && options.lang, 'Bool Field') : undefined,
        'aria-required': field._isRequired ? field._isRequired : undefined
      };
      return normalizeProps(createComponentVNode(2, Input, _objectSpread({
        "type": "checkbox",
        "id": generateId(namespace, '__Field'),
        "name": inputName
      }, ariaLabels, {
        "valid": isValid,
        "placeholder": renderString(field.placeholder, options && options.lang),
        "readOnly": field.readOnly,
        "checked": this.state.isChecked,
        "onChange": this.didGetChange
      })));
    }
  }]);

  return CheckboxWidget;
}(Component);

export default CheckboxWidget;
new Adapter({
  implements: IInputFieldWidget,
  adapts: interfaces.IBoolField,
  Component: CheckboxWidget
});
//# sourceMappingURL=BoolField.js.map