'use strict';
/*

    To use this input widget adapter you need to register it with your
    adapter registry.

*/

import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import { createVNode, createComponentVNode, normalizeProps } from "inferno";
import { Component } from 'inferno';
import { Adapter } from 'component-registry';
import { interfaces } from 'isomorphic-schema';
import { IInputFieldWidget } from '../interfaces';
import { renderString } from './common';
import { generateId } from './utils';
import { Input } from 'inferno-bootstrap'; // Placeholder

var DynamicSelectFieldWidget =
/*#__PURE__*/
function (_Component) {
  _inherits(DynamicSelectFieldWidget, _Component);

  function DynamicSelectFieldWidget(props) {
    var _this;

    _classCallCheck(this, DynamicSelectFieldWidget);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DynamicSelectFieldWidget).call(this, props));
    _this.didGetChange = _this.didGetChange.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    return _this;
  }

  _createClass(DynamicSelectFieldWidget, [{
    key: "didGetChange",
    value: function didGetChange(e) {
      var field = this.props.adapter.context;
      this.props.onChange(this.props.propName, field.fromString(field.valueType.fromString(e.target.value)));
    }
  }, {
    key: "render",
    value: function render(_ref) {
      var inputName = _ref.inputName,
          namespace = _ref.namespace,
          options = _ref.options,
          doesNotRenderLabel = _ref.doesNotRenderLabel,
          id = _ref.id;
      var field = this.props.adapter.context;
      var selectOptions = field.getOptions(this.props.value, Object.assign({
        rootValue: this.context.rootValue
      }, options));
      var isValid = this.props.validationError || this.props.invariantError ? false : undefined;
      var lang = options.lang;
      var ariaLabels = {
        'aria-invalid': isValid !== undefined,
        'aria-labelledby': doesNotRenderLabel ? undefined : id,
        'aria-label': doesNotRenderLabel ? renderString(field.label || 'inferno-formlib--InputField', options && options.lang, 'DynamicSelect Field') : undefined,
        'aria-required': field._isRequired ? field._isRequired : undefined
      };
      return normalizeProps(createComponentVNode(2, Input, _objectSpread({
        "type": "select",
        "id": generateId(namespace, '__Field'),
        "name": inputName,
        "valid": isValid
      }, ariaLabels, {
        "readOnly": field.readOnly,
        "value": field.valueType.toFormattedString(field.toFormattedString(this.props.value)),
        "onChange": this.didGetChange,
        children: [field.placeholder && createVNode(1, "option", null, renderString(field.placeholder, lang, undefined), 0, {
          "value": ""
        }), selectOptions.map(function (item) {
          return createVNode(1, "option", null, renderString(item.title, lang, undefined), 0, {
            "value": item.name
          });
        })]
      })));
    }
  }]);

  return DynamicSelectFieldWidget;
}(Component);

export default DynamicSelectFieldWidget;
new Adapter({
  implements: IInputFieldWidget,
  adapts: interfaces.IDynamicSelectBaseField,
  Component: DynamicSelectFieldWidget
});
//# sourceMappingURL=DynamicSelectField.js.map