import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import { createVNode } from "inferno";
import { Component } from 'inferno';
import classNames from 'classnames';
export var DragNDrop =
/*#__PURE__*/
function (_Component) {
  _inherits(DragNDrop, _Component);

  function DragNDrop(props) {
    var _this;

    _classCallCheck(this, DragNDrop);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DragNDrop).call(this, props));
    _this.state = {
      inDragCount: 0,
      isDragging: false // I need to bind these event handlers to this, and
      // I only want to do it once to make sure they can be
      // removed properly

    };
    _this.setDrag = _this.setDrag.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.onDocumentDrag = _this.onDocumentDrag.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.onDocumentDragEnd = _this.onDocumentDragEnd.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.onDragEnter = _this.onDragEnter.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.onDragLeave = _this.onDragLeave.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.onDrop = _this.onDrop.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.onDragOver = _this.onDragOver.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.componentDidMount = _this.componentDidMount.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.onDragEnd = _this.onDragEnd.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    return _this;
  }

  _createClass(DragNDrop, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      // TODO: Should we only register a single event handler here which
      // triggers dragStart? This is just a bit weird.
      this.dragStart();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this._unregisterEventHandlers();
    }
  }, {
    key: "setDrag",
    value: function setDrag(change) {
      var inDragCount = this.state.inDragCount + change;

      if (inDragCount >= 0) {
        this.setState({
          inDragCount: inDragCount
        });
      }
    }
  }, {
    key: "element",
    value: function element() {
      return this.dropArea;
    }
  }, {
    key: "onDocumentDrag",
    value: function onDocumentDrag(e) {
      if (!this.state.isDragging) {
        this.setState({
          isDragging: true
        });
      }
    }
  }, {
    key: "onDocumentDragEnd",
    value: function onDocumentDragEnd(e) {
      if (this.state.isDragging && !e.relatedTarget) {
        this.setState({
          isDragging: false
        });
      }
    }
  }, {
    key: "onDragEnter",
    value: function onDragEnter(e) {
      e.preventDefault();
      this.setDrag(1);
    }
  }, {
    key: "onDragLeave",
    value: function onDragLeave(e) {
      this.setDrag(-1);
    }
  }, {
    key: "onDragEnd",
    value: function onDragEnd(e) {
      this._unregisterEventHandlers();
    }
  }, {
    key: "onDrop",
    value: function onDrop(e) {
      e.preventDefault();
      this.setState({
        inDragCount: 0,
        isDragging: false
      });

      if (this.props.multiFile) {
        var files = e.dataTransfer.files;
        this.props.onDrop(files);
      } else {
        var file = e.dataTransfer.files[0]; // console.log("[DragNDrop] file:", file.name);

        this.props.onDrop(file, file.name);
      } // TODO: Why did we do this? It disables drag'n'drop
      // this._unregisterEventHandlers()

    }
  }, {
    key: "onDragOver",
    value: function onDragOver(e) {
      e.preventDefault();
    }
  }, {
    key: "dragStart",
    value: function dragStart() {
      this._registerEventHandlers();
    }
  }, {
    key: "_registerEventHandlers",
    value: function _registerEventHandlers() {
      var el = this.element();

      if (el) {
        el.addEventListener('dragenter', this.onDragEnter);
        el.addEventListener('dragleave', this.onDragLeave);
        el.addEventListener('dragover', this.onDragOver);
        el.addEventListener('drop', this.onDrop);
        el.addEventListener('dragend', this.onDragEnd);
      }

      document.addEventListener("dragenter", this.onDocumentDrag);
      document.addEventListener("dragleave", this.onDocumentDragEnd);
    }
  }, {
    key: "_unregisterEventHandlers",
    value: function _unregisterEventHandlers() {
      var el = this.element();

      if (el) {
        el.removeEventListener('dragenter', this.onDragEnter);
        el.removeEventListener('dragleave', this.onDragLeave);
        el.removeEventListener('dragover', this.onDragOver);
        el.removeEventListener('drop', this.onDrop);
        el.removeEventListener('dragend', this.onDragEnd);
      }

      document.removeEventListener("dragenter", this.ondDrag);
      document.removeEventListener("dragleave", this.onDocumentDragEnd);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var cls = classNames('DragNDroppable', {
        'DragNDroppable--drag-hover': this.state.inDragCount > 0,
        'DragNDroppable--drag': this.state.isDragging
      });
      return createVNode(1, "div", cls, this.props.children, 0, null, null, function (el) {
        _this2.dropArea = el;
      });
    }
  }]);

  return DragNDrop;
}(Component);
//# sourceMappingURL=DragNDrop.js.map