'use strict';
/*

    To use this input widget adapter you need to register it with your
    adapter registry.

*/

import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import { createComponentVNode, normalizeProps } from "inferno";
import { Component } from 'inferno';
import { Adapter } from 'component-registry';
import { renderString } from './common';
import { interfaces } from 'isomorphic-schema';
import { IInputFieldWidget } from '../interfaces';
import { Input } from 'inferno-bootstrap';
import { generateId } from './utils'; // Placeholder

var PasswordWidget =
/*#__PURE__*/
function (_Component) {
  _inherits(PasswordWidget, _Component);

  function PasswordWidget(props) {
    var _this;

    _classCallCheck(this, PasswordWidget);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PasswordWidget).call(this, props));
    _this.state = {
      value: props.value
    };
    _this.didGetInput = _this.didGetInput.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.didGetChange = _this.didGetChange.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    return _this;
  }

  _createClass(PasswordWidget, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      this.setState({
        value: nextProps.value
      });
    }
  }, {
    key: "didGetInput",
    value: function didGetInput(e) {
      var field = this.props.adapter.context;
      var newVal = field.fromString(e.target.value);
      this.setState({
        value: newVal
      });
    }
  }, {
    key: "didGetChange",
    value: function didGetChange(e) {
      this.props.onChange(this.props.propName, this.state.value);
    }
  }, {
    key: "render",
    value: function render(_ref) {
      var inputName = _ref.inputName,
          namespace = _ref.namespace,
          options = _ref.options,
          doesNotRenderLabel = _ref.doesNotRenderLabel,
          id = _ref.id;
      var field = this.props.adapter.context;
      var isValid = this.props.validationError || this.props.invariantError ? false : undefined;
      var ariaLabels = {
        'aria-invalid': isValid !== undefined,
        'aria-labelledby': doesNotRenderLabel ? undefined : id,
        'aria-label': doesNotRenderLabel ? renderString(field.label || 'inferno-formlib--InputField', options && options.lang, 'Password Field') : undefined,
        'aria-required': field._isRequired ? field._isRequired : undefined
      };
      return normalizeProps(createComponentVNode(2, Input, _objectSpread({
        "type": "password",
        "id": generateId(namespace, '__Field'),
        "name": inputName,
        "placeholder": renderString(field.placeholder, options && options.lang),
        "readOnly": field.readOnly,
        "value": this.state.value,
        "valid": isValid
      }, ariaLabels, {
        "onInput": this.didGetInput,
        "onChange": this.didGetChange
      })));
    }
  }]);

  return PasswordWidget;
}(Component);

export default PasswordWidget;
new Adapter({
  implements: IInputFieldWidget,
  adapts: interfaces.IPasswordField,
  Component: PasswordWidget
});
//# sourceMappingURL=PasswordField.js.map